﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Core;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Operators;
using HeuristicLab.Optimization;
using HeuristicLab.Parameters;
using HeuristicLab.Data;
using HeuristicLab.Common;
using System.Threading;
using System.Threading.Tasks;
using HeuristicLab.Encodings.PermutationEncoding;
using HeuristicLab.Encodings.RealVectorEncoding;
using System.Diagnostics;

namespace HeuristicLab.PDPSimulation.Operators {
  [Item("LinearPriorityDispatchingMetaOptEvaluator", "Metaoptimization of the priority dispatching parameters for the PDP simulation.")]
  [StorableClass]
  public class LinearPriorityDispatchingMetaOptEvaluator : PriorityDispatchingMetaOptEvaluator {
    public IValueLookupParameter<DoubleArray> VectorParameter {
      get { return (IValueLookupParameter<DoubleArray>)Parameters["Vector"]; }
    }

    public LinearPriorityDispatchingMetaOptEvaluator() {
      Parameters.Add(new ValueLookupParameter<DoubleArray>("Vector", "The priority dispatching parameters."));
    }

    [StorableConstructor]
    protected LinearPriorityDispatchingMetaOptEvaluator(bool deserializing) : base(deserializing) { }
    protected LinearPriorityDispatchingMetaOptEvaluator(LinearPriorityDispatchingMetaOptEvaluator original, Cloner cloner) : base(original, cloner) { }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new LinearPriorityDispatchingMetaOptEvaluator(this, cloner);
    }

    protected override void Parameterize(PriorityDispatching dispatching) {
      DoubleArray vector = VectorParameter.ActualValue;

      LinearPriorityDispatching linearDispatching = dispatching as LinearPriorityDispatching;
      linearDispatching.WeightsParameter.Value = new RealVector(vector.ToArray());
    }
  }
}
